/*****************************************************************************
Copyright (c) 2011 SmartVault, Inc.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ******************************************************************************/
package com.smartvault.exceptions;

public class SmartVaultException extends Exception {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private int errorCode;
	private String errorText;
	private String correctiveUri;
	private String helpUri;
	private String instanceGuid;
	private int statusCode;
	

	public SmartVaultException(final int errorCode, final String errorText,
			final String correctiveUri, final String helpUri, final String instanceGuid,
			final int statusCode) {
		super(errorText);
		this.errorCode = errorCode;
		this.errorText = errorText;
		this.correctiveUri = correctiveUri;
		this.helpUri = helpUri;
		this.instanceGuid = instanceGuid;
		this.statusCode = statusCode;
	}

	public int getErrorCode() {
		return this.errorCode;
	}

	public String getErrorText() {
		return this.errorText;
	}

	public String getCorrectiveUri() {
		return this.correctiveUri;
	}

	public String getHelpUri() {
		return this.helpUri;
	}

	public String getInstanceGuid() {
		return this.instanceGuid;
	}

	public int getStatusCode() {
		return this.statusCode;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "SmartVaultException [errorCode=" //$NON-NLS-1$
				+ this.errorCode
				+ ", " //$NON-NLS-1$
				+ (this.errorText != null ? "errorText=" + this.errorText + ", " : "")  //$NON-NLS-1$ //$NON-NLS-2$//$NON-NLS-3$
				+ (this.correctiveUri != null ? "correctiveUri=" + this.correctiveUri //$NON-NLS-1$
						+ ", " : "") //$NON-NLS-1$ //$NON-NLS-2$
				+ (this.helpUri != null ? "helpUri=" + this.helpUri + ", " : "")  //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$
				+ (this.instanceGuid != null ? "instanceGuid=" + this.instanceGuid + ", " //$NON-NLS-1$ //$NON-NLS-2$
						: "") + "statusCode=" + this.statusCode + "]";   //$NON-NLS-1$ //$NON-NLS-2$//$NON-NLS-3$
	}
}
